/*****************************************************************************
     This file is part of the Changedfiles system. 

     Copright (C)2001  Michael L. Welles

     This program is free software; you can redistribute it and/or modify
     it under the terms of the GNU General Public License as published by
     the Free Software Foundation; either version 2 of the License, or
     (at your option) any later version.

     This program is distributed in the hope that it will be useful,
     but WITHOUT ANY WARRANTY; without even the implied warranty of
     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
     GNU General Public License for more details.

     You should have received a copy of the GNU General Public License
     along with this program; if not, write to the Free Software
     Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*******************************************************************************/
/* $Id: logger.h,v 1.4 2002/01/30 20:44:08 philip Exp $ */ 
#ifndef _LOGGER_H_ 
#define _LOGGER_H_
#include <string> 
#include <stdio.h>

namespace{
  string DEFAULT_LOG_FILE = "/var/log/changedfiles.log"; 
}

class Logger
{ 
 public: 
  enum log_type { DEBUG, INFO, NOTICE, WARNING, ERR, CRIT, ALERT, EMERG }; 
  void log( log_type logtype, string msg ); 
  void log( log_type logtype, const char * msg ); 
  void set_logfile( string log_file); 
  static Logger * get_instance(); 
  bool open_log(); 
  bool close_log(); 
  bool is_instantiated(); 

 protected: 
  
  Logger(); 
  ~Logger(); 

 private: 
  string m_logfile_name; 
  static Logger * m_logger; 
  bool m_logger_instantiated; 
  FILE* m_logfile_file_p; 

}; 
#endif

 
